<?php
/* $Id: login.php 59 2010-02-20 00:13:42Z mir $ */

if (! file_exists('config.inc.php'))
    throw new Exception("The application is not configured yet");

include_once 'config.inc.php';

if (isset($_SESSION['attemps']))
    $_SESSION['attemps']++;
else
    $_SESSION['attemps'] = 1;

if ($_SESSION['attemps'] == 1) {
    $_SESSION['authenticate'] = new Authenticate(DBDRIVER);
}

/*
 * To avoid bots, script kiddeis or other password harvester
 * add a 5 seconds delay for every 5 failed attemps
 */
if ($_SESSION['attemps'] > 5) {
    sleep(5);
    header('Location: logout.php');
}

$auth = $_SESSION['authenticate'];

$auth->login($_POST['uid'], $_POST['pwd']);
if ($auth->validUser()) {
    unset($_SESSION['attemps']);
    $_SESSION['user_settings'] = new UserSettings($_POST['uid']);
    $_SESSION['user_settings']->setSettings(
        $_SESSION['authenticate']->getSettings());
    //var_dump($_SESSION['user_settings']);
    //var_dump($_SESSION['authenticate']->getSettings());
    header('Location: index.php');
    exit();
}

include 'include/header.inc.php';
$email = ADMIN_MAIL;
$action = $_SERVER['PHP_SELF'];

print <<< _HTML
<div id="login_msg">
    <form action="$action" method="post">
        <table>
            <tr>
                <td>Username</td><td><input id="uid" type="text" name="uid"/></td>
            </tr>
            <tr>
                <td>Password</td><td><input type="password" name="pwd"/></td>
            </tr>
            <tr>
                <td colspan="2" style="text-align: center">
                    <input type="reset" value="Clear"/>
                    <input type="submit" name="submit" value="Login"/>
                </td>
            </tr>
            <tr>
                <td colspan="2" style="text-align: center">If you don't have an account
                    <a href="mailto:$email?subject=Requesting an account">apply</a>
                </td>
            </tr>
        </table>
    </form>
</div>
<script type="text/javascript">
    focus("uid");
</script>
_HTML;

include 'include/footer.inc.php';

?>
